## libkgapi 5.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(kgapi)

# ECM setup
find_package(ECM 5.12.0 CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(ECMPackageConfigHelpers)
include(ECMPoQmTools)
include(ECMSetupVersion)
include(FeatureSummary)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings)

set(KGAPI_LIB_VERSION "5.1.0")

set(KDEPIMLIBS_LIB_VERSION "4.88.0")
set(KF5_VERSION "5.12.0")
set(KCALENDARCORE_LIB_VERSION "4.81.0")
set(KCONTACTS_LIB_VERSION "4.91.0")

add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x049999)  #needed for QUrl::addQueryItems usage

ecm_setup_version(${KGAPI_LIB_VERSION}
    VARIABLE_PREFIX KGAPI
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kgapi_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5GAPIConfigVersion.cmake"
    SOVERSION 5
)

############## Find Packages ##############
set(REQUIRED_QT_VERSION "5.2.0")
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS
    Core
    Widgets
    WebKitWidgets
    Xml
)

find_package(KF5 ${KF5_VERSION} REQUIRED COMPONENTS
    CoreAddons
    KIO
    WindowSystem
)

find_package(KF5CalendarCore ${KCALENDARCORE_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Contacts ${KCONTACTS_LIB_VERSION} CONFIG REQUIRED)

############## Targets ##############

add_definitions(-DTRANSLATION_DOMAIN=\"libkgapi\")

add_subdirectory(src)
add_subdirectory(examples)
#add_subdirectory(autotests)

if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
   ecm_install_po_files_as_qm(po)
endif()

############## CMake Config Files ##############
message("${CMAKECONFIG_INSTALL_DIR}")
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5GAPI")

ecm_configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KF5GAPIConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5GAPIConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KF5GAPIConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5GAPIConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

install(EXPORT KF5GAPITargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE KF5GAPITargets.cmake
    NAMESPACE KF5::
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/kgapi_version.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}"
    COMPONENT Devel
)

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
add_subdirectory(contacts)
#add_subdirectory(staticmaps)

=== tests/CMakeLists.txt ===
include(ECMMarkAsTest)

find_package(Qt5Test CONFIG REQUIRED)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

MACRO(LIBKGAPI_TESTS)
       FOREACH(_testname ${ARGN})
               add_executable( ${_testname} ${_testname}.cpp )
               add_test( ${_testname} ${_testname} )
               ecm_mark_as_test(libkgapi-${_testname})
               target_link_libraries(${_testname}
                                     Qt5::Test
                                     KF5::Contacts
                                     KF5::Mime
                                     KF5::CalendarCore
                                     KF5::KIOCore
                                     kgapi)
       ENDFOREACH(_testname)
ENDMACRO(LIBKGAPI_TESTS)

macro(add_libkgapi2_test _module _testname)
    add_executable( ${_module}-${_testname} ${_module}/${_testname}.cpp )
    add_test( ${_module}-${_testname} ${_module}-${_testname} )
    ecm_mark_as_test(libkgapi2-${_module}-${_testname})
    target_link_libraries(${_module}-${_testname}
                          Qt5::Test
                          KF5::Contacts
                          KF5::CalendarCore
                          KF5GAPIDrive)
endmacro(add_libkgapi2_test)

#LIBKGAPI_TESTS(
#    objectsaccountinfotests
#    objectscalendartests
#    objectscontacttests
#    objectscontactsgrouptests
#    objectseventtests
#    objectstasktests
#    objectstasklisttests
#    objectslocationtests
#    objectstaticmapurltests
#    servicesaccountinfotests
#    servicescalendartests
#    servicescontactstests
#    serviceslatitudetests
#    servicestaskstests
#)

add_libkgapi2_test(drive filesearchquerytest)

=== examples/contacts/CMakeLists.txt ===
project(contacts-example)

kde_enable_exceptions()

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}
)

set(contacts_example_SRCS main.cpp mainwindow.cpp)
set(contacts_example_HDRS mainwindow.h)
qt5_wrap_ui(contacts_example_SRCS ui/main.ui)

add_executable(contacts-example
        ${contacts_example_SRCS}
        ${contacts_example_HDRS_MOC}
)

target_link_libraries(contacts-example
        KF5::Contacts
        Qt5::Widgets
        Qt5::Core
        KF5::GAPICore
        KF5::GAPIContacts
)

=== src/blogger/CMakeLists.txt ===
set(kgapiblogger_SRCS
    blog.cpp
    blogfetchjob.cpp
    bloggerservice.cpp
    comment.cpp
    commentapprovejob.cpp
    commentdeletecontentjob.cpp
    commentdeletejob.cpp
    commentfetchjob.cpp
    page.cpp
    pagecreatejob.cpp
    pagedeletejob.cpp
    pagefetchjob.cpp
    pagemodifyjob.cpp
    post.cpp
    postcreatejob.cpp
    postdeletejob.cpp
    postfetchjob.cpp
    postmodifyjob.cpp
    postpublishjob.cpp
    postsearchjob.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapiblogger_CamelCase_HEADERS
    HEADER_NAMES
    Blog
    BlogFetchJob
    Comment
    CommentApproveJob
    CommentDeleteContentJob
    CommentDeleteJob
    CommentFetchJob
    Page
    PageCreateJob
    PageDeleteJob
    PageFetchJob
    PageModifyJob
    Post
    PostCreateJob
    PostDeleteJob
    PostFetchJob
    PostModifyJob
    PostPublishJob
    PostSearchJob
    PREFIX KGAPI/Blogger
    REQUIRED_HEADERS kgapiblogger_HEADERS
)

add_library(KF5GAPIBlogger
    ${kgapiblogger_SRCS}
)

generate_export_header(KF5GAPIBlogger BASE_NAME kgapiblogger)

add_library(KF5::GAPIBlogger ALIAS KF5GAPIBlogger)
target_include_directories(KF5GAPIBlogger INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPIBlogger
PUBLIC
    KF5::GAPICore
PRIVATE
    Qt5::Network
)

set_target_properties(KF5GAPIBlogger PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPIBlogger
)

install(TARGETS
    KF5GAPIBlogger
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapiblogger_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Blogger"
    COMPONENT Devel
)

install(FILES
    ${kgapiblogger_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapiblogger_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/blogger"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPIBlogger
    LIB_NAME KF5GAPIBlogger
    DEPS "GAPICore"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/calendar/CMakeLists.txt ===
set(kgapicalendar_SRCS
    calendar.cpp
    calendarcreatejob.cpp
    calendardeletejob.cpp
    calendarfetchjob.cpp
    calendarmodifyjob.cpp
    calendarservice.cpp
    event.cpp
    eventcreatejob.cpp
    eventdeletejob.cpp
    eventfetchjob.cpp
    eventmodifyjob.cpp
    eventmovejob.cpp
    reminder.cpp
    freebusyqueryjob.cpp
    ../debug.cpp
)

ecm_generate_headers(kgapicalendar_CamelCase_HEADERS
    HEADER_NAMES
    Calendar
    CalendarCreateJob
    CalendarDeleteJob
    CalendarFetchJob
    CalendarModifyJob
    Event
    EventCreateJob
    EventDeleteJob
    EventFetchJob
    EventModifyJob
    EventMoveJob
    Reminder
    FreeBusyQueryJob
    PREFIX KGAPI/Calendar
    REQUIRED_HEADERS kgapicalendar_HEADERS
)

add_library(KF5GAPICalendar
    ${kgapicalendar_SRCS}
)

generate_export_header(KF5GAPICalendar BASE_NAME kgapicalendar)

add_library(KF5::GAPICalendar ALIAS KF5GAPICalendar)
target_include_directories(KF5GAPICalendar INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPICalendar
PUBLIC
    KF5::GAPICore
    KF5::CalendarCore
)

set_target_properties(KF5GAPICalendar PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPICalendar
)

install(TARGETS
    KF5GAPICalendar
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapicalendar_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Calendar"
    COMPONENT Devel
)

install(FILES
    ${kgapicalendar_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapicalendar_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/calendar"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPICalendar
    LIB_NAME KF5GAPICalendar
    DEPS "GAPICore CalendarCore"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/contacts/CMakeLists.txt ===
set(kgapicontacts_SRCS
    contact.cpp
    contactcreatejob.cpp
    contactdeletejob.cpp
    contactfetchjob.cpp
    contactfetchphotojob.cpp
    contactmodifyjob.cpp
    contactsgroup.cpp
    contactsgroupcreatejob.cpp
    contactsgroupdeletejob.cpp
    contactsgroupfetchjob.cpp
    contactsgroupmodifyjob.cpp
    contactsservice.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapicontacts_CamelCase_HEADERS
    HEADER_NAMES
    Contact
    ContactCreateJob
    ContactDeleteJob
    ContactFetchJob
    ContactFetchPhotoJob
    ContactModifyJob
    ContactsGroup
    ContactsGroupCreateJob
    ContactsGroupDeleteJob
    ContactsGroupFetchJob
    ContactsGroupModifyJob
    PREFIX KGAPI/Contacts
    REQUIRED_HEADERS kgapicontacts_HEADERS
)

add_library(KF5GAPIContacts
    ${kgapicontacts_SRCS}
)

generate_export_header(KF5GAPIContacts BASE_NAME kgapicontacts)

add_library(KF5::GAPIContacts ALIAS KF5GAPIContacts)
target_include_directories(KF5GAPIContacts INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPIContacts
PUBLIC
    KF5::GAPICore
    KF5::Contacts
PRIVATE
    Qt5::Xml
    Qt5::Network
)

set_target_properties(KF5GAPIContacts PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPIContacts
)

install(TARGETS
    KF5GAPIContacts
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapicontacts_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Contacts"
    COMPONENT Devel
)

install(FILES
    ${kgapicontacts_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapicontacts_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/contacts"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPIContacts
    LIB_NAME KF5GAPIContacts
    DEPS "KF5::GAPICore KF5::Contacts Qt5::Xml"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/core/CMakeLists.txt ===
ecm_create_qm_loader(QM_LOADER libkgapi_qt)

set(kgapicore_SRCS
    accountinfo/accountinfo.cpp
    accountinfo/accountinfofetchjob.cpp
    private/newtokensfetchjob.cpp
    ui/authwidget.cpp
    ui/authwidget_p.cpp
    account.cpp
    authjob.cpp
    createjob.cpp
    deletejob.cpp
    fetchjob.cpp
    job.cpp
    modifyjob.cpp
    object.cpp
    utils.cpp
    ${QM_LOADER}

    ../debug.cpp
)

ecm_generate_headers(kgapicore_base_CamelCase_HEADERS
    HEADER_NAMES
    Account
    AuthJob
    CreateJob
    DeleteJob
    FetchJob
    Job
    ModifyJob
    Object
    Types
    Utils
    PREFIX KGAPI
    REQUIRED_HEADERS kgapicore_base_HEADERS
)

ecm_generate_headers(kgapicore_accountinfo_CamelCase_HEADERS
    HEADER_NAMES
    AccountInfo
    AccountInfoFetchJob
    REQUIRED_HEADERS kgapicore_accountinfo_HEADERS
    RELATIVE accountinfo
)

ecm_generate_headers(kgapicore_ui_CamelCase_HEADERS
    HEADER_NAMES
    AuthWidget
    REQUIRED_HEADERS kgapicore_ui_HEADERS
    RELATIVE ui
)

add_library(KF5GAPICore
    ${kgapicore_SRCS}
)

generate_export_header(KF5GAPICore BASE_NAME kgapicore)

add_library(KF5::GAPICore ALIAS KF5GAPICore)
target_include_directories(KF5GAPICore INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI;${KF5_INCLUDE_INSTALL_DIR}/KGAPI/kgapi>")

target_link_libraries(KF5GAPICore
PRIVATE
    KF5::KIOWidgets
    KF5::WindowSystem
    Qt5::WebKitWidgets
PUBLIC
    Qt5::Widgets
)

set_target_properties(KF5GAPICore PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPICore
)

install(TARGETS
    KF5GAPICore
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapicore_base_CamelCase_HEADERS}
    ${kgapicore_accountinfo_CamelCase_HEADERS}
    ${kgapicore_ui_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI"
    COMPONENT Devel
)

install(FILES
    ${kgapicore_base_HEADERS}
    ${kgapicore_accountinfo_HEADERS}
    ${kgapicore_ui_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapicore_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPICore
    LIB_NAME KF5GAPICore
    DEPS "KF5::CoreAddons Qt5::Widgets Qt5::WebKitWidgets"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/drive/CMakeLists.txt ===
set(kgapidrive_SRCS
    about.cpp
    aboutfetchjob.cpp
    app.cpp
    appfetchjob.cpp
    change.cpp
    changefetchjob.cpp
    childreference.cpp
    childreferencecreatejob.cpp
    childreferencedeletejob.cpp
    childreferencefetchjob.cpp
    driveservice.cpp
    file.cpp
    fileabstractdatajob.cpp
    fileabstractmodifyjob.cpp
    fileabstractuploadjob.cpp
    filecopyjob.cpp
    filecreatejob.cpp
    filedeletejob.cpp
    filefetchcontentjob.cpp
    filefetchjob.cpp
    filemodifyjob.cpp
    filesearchquery.cpp
    filetouchjob.cpp
    filetrashjob.cpp
    fileuntrashjob.cpp
    parentreference.cpp
    parentreferencecreatejob.cpp
    parentreferencedeletejob.cpp
    parentreferencefetchjob.cpp
    permission.cpp
    permissioncreatejob.cpp
    permissiondeletejob.cpp
    permissionfetchjob.cpp
    permissionmodifyjob.cpp
    revision.cpp
    revisiondeletejob.cpp
    revisionfetchjob.cpp
    revisionmodifyjob.cpp
    user.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapidrive_CamelCase_HEADERS
    HEADER_NAMES
    About
    AboutFetchJob
    App
    AppFetchJob
    Change
    ChangeFetchJob
    ChildReference
    ChildReferenceCreateJob
    ChildReferenceDeleteJob
    ChildReferenceFetchJob
    File
    FileAbstractDataJob
    FileAbstractModifyJob
    FileAbstractUploadJob
    FileCopyJob
    FileCreateJob
    FileDeleteJob
    FileFetchContentJob
    FileFetchJob
    FileModifyJob
    FileSearchQuery
    FileTouchJob
    FileTrashJob
    FileUntrashJob
    ParentReference
    ParentReferenceCreateJob
    ParentReferenceDeleteJob
    ParentReferenceFetchJob
    Permission
    PermissionCreateJob
    PermissionDeleteJob
    PermissionFetchJob
    PermissionModifyJob
    Revision
    RevisionDeleteJob
    RevisionFetchJob
    RevisionModifyJob
    User
    PREFIX KGAPI/Drive
    REQUIRED_HEADERS kgapidrive_HEADERS
)

add_library(KF5GAPIDrive
    ${kgapidrive_SRCS}
)

generate_export_header(KF5GAPIDrive BASE_NAME kgapidrive)

add_library(KF5::GAPIDrive ALIAS KF5GAPIDrive)
target_include_directories(KF5GAPIDrive INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPIDrive
PUBLIC
    KF5::GAPICore
PRIVATE
    Qt5::Network
)

set_target_properties(KF5GAPIDrive PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPIDrive
)

install(TARGETS
    KF5GAPIDrive
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapidrive_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Drive"
    COMPONENT Devel
)

install(FILES
    ${kgapidrive_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapidrive_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/drive"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPIDrive
    LIB_NAME KF5GAPIDrive
    DEPS "GAPICore"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/latitude/CMakeLists.txt ===
set(kgapilatitude_SRCS
    latitudeservice.cpp
    latitude.h
    location.cpp
    locationcreatejob.cpp
    locationdeletejob.cpp
    locationfetchhistoryjob.cpp
    locationfetchjob.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapilatitude_CamelCase_HEADERS
    HEADER_NAMES
    Location
    LocationCreateJob
    LocationDeleteJob
    LocationFetchHistoryJob
    LocationFetchJob
    Latitude
    PREFIX KGAPI/Latitude
    REQUIRED_HEADERS kgapilatitude_HEADERS
)

add_library(KF5GAPILatitude
    ${kgapilatitude_SRCS}
)

generate_export_header(KF5GAPILatitude BASE_NAME kgapilatitude)

add_library(KF5::GAPILatitude ALIAS KF5GAPILatitude)
target_include_directories(KF5GAPILatitude INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPILatitude
PUBLIC
    KF5::GAPICore
    KF5::Contacts
PRIVATE
    Qt5::Network
)

set_target_properties(KF5GAPILatitude PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPILatitude
)

install(TARGETS
    KF5GAPILatitude
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapilatitude_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Latitude"
    COMPONENT Devel
)

install(FILES
    ${kgapilatitude_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapilatitude_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/latitude"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPILatitude
    LIB_NAME KF5GAPILatitude
    DEPS "GAPICore Contacts"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/staticmaps/CMakeLists.txt ===
set(kgapimaps_SRCS
    staticmapmarker.cpp
    staticmappath.cpp
    staticmaptilefetchjob.cpp
    staticmapurl.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapimaps_CamelCase_HEADERS
    HEADER_NAMES
    StaticMapMarker
    StaticMapPath
    StaticMapTileFetchJob
    StaticMapUrl
    PREFIX KGAPI/Maps
    REQUIRED_HEADERS kgapimaps_HEADERS
)

add_library(KF5GAPIMaps
    ${kgapimaps_SRCS}
)

generate_export_header(KF5GAPIMaps BASE_NAME kgapimaps)

add_library(KF5::GAPIMaps ALIAS KF5GAPIMaps)
target_include_directories(KF5GAPIMaps INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPIMaps
PUBLIC
    KF5::GAPICore
    KF5::Contacts
PRIVATE
    Qt5::Network
)

set_target_properties(KF5GAPIMaps PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPIMaps
)

install(TARGETS
    KF5GAPIMaps
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapimaps_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Maps"
    COMPONENT Devel
)

install(FILES
    ${kgapimaps_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapimaps_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/maps"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPIMaps
    LIB_NAME KF5GAPIMaps
    DEPS "GAPICore Contacts"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== src/tasks/CMakeLists.txt ===
set(kgapitasks_SRCS
    task.cpp
    taskcreatejob.cpp
    taskdeletejob.cpp
    taskfetchjob.cpp
    tasklist.cpp
    tasklistcreatejob.cpp
    tasklistdeletejob.cpp
    tasklistfetchjob.cpp
    tasklistmodifyjob.cpp
    taskmodifyjob.cpp
    taskmovejob.cpp
    tasksservice.cpp

    ../debug.cpp
)

ecm_generate_headers(kgapitasks_CamelCase_HEADERS
    HEADER_NAMES
    Task
    TaskCreateJob
    TaskDeleteJob
    TaskFetchJob
    TaskList
    TaskListCreateJob
    TaskListDeleteJob
    TaskListFetchJob
    TaskListModifyJob
    TaskModifyJob
    TaskMoveJob
    PREFIX KGAPI/Tasks
    REQUIRED_HEADERS kgapitasks_HEADERS
)

add_library(KF5GAPITasks
    ${kgapitasks_SRCS}
)

generate_export_header(KF5GAPITasks BASE_NAME kgapitasks)

add_library(KF5::GAPITasks ALIAS KF5GAPITasks)
target_include_directories(KF5GAPITasks INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI>")

target_link_libraries(KF5GAPITasks
PUBLIC
    KF5::GAPICore
    KF5::CalendarCore
)

set_target_properties(KF5GAPITasks PROPERTIES
    VERSION ${KGAPI_VERSION_STRING}
    SOVERSION ${KGAPI_SOVERSION}
    EXPORT_NAME GAPITasks
)

install(TARGETS
    KF5GAPITasks
    EXPORT KF5GAPITargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(FILES
    ${kgapitasks_CamelCase_HEADERS}
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/KGAPI/Tasks"
    COMPONENT Devel
)

install(FILES
    ${kgapitasks_HEADERS}
    "${CMAKE_CURRENT_BINARY_DIR}/kgapitasks_export.h"
    DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI/kgapi/tasks"
    COMPONENT Devel
)

ecm_generate_pri_file(BASE_NAME KGAPITasks
    LIB_NAME KF5GAPITasks
    DEPS "GAPICore CalendarCore"
    FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR "${KDE_INSTALL_INCLUDEDIR_KF5}/KGAPI"
)

install(FILES
    "${PRI_FILENAME}"
    DESTINATION "${ECM_MKSPECS_INSTALL_DIR}"
)

=== debian/changelog ===
libkgapi (5.1.0-1ubuntu1) xenial; urgency=medium

  [ Scarlett Clark ]
  * Debian merge: No remaining changes. 

 -- Philip Muškovac <yofel@kubuntu.org>  Wed, 09 Mar 2016 10:36:05 +0100

libkgapi (5.1.0-1) experimental; urgency=medium

  * New upstream release (5.1.0).

 -- Maximiliano Curia <maxy@debian.org>  Mon, 01 Feb 2016 11:32:10 +0100

libkgapi (5.0.0-1) experimental; urgency=medium

  * New upstream release (5.0.0).

 -- Maximiliano Curia <maxy@debian.org>  Wed, 09 Sep 2015 18:11:04 +0200

libkgapi (2.2.0-2) unstable; urgency=medium

  * Add libsoprano-dev build dep.
  * Bump Standards-Version to 3.9.6, no changes needed.

 -- Maximiliano Curia <maxy@debian.org>  Mon, 31 Aug 2015 23:09:06 +0200

=== debian/control ===
Source: libkgapi
Section: libs
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.8.12~),
               debhelper (>= 9),
               extra-cmake-modules (>= 5.12.0~),
               kio-dev (>= 5.12.0~),
               libkf5calendarcore-dev (>= 4.81.0~),
               libkf5contacts-dev (>= 4.91.0~),
               libkf5coreaddons-dev (>= 5.12.0~),
               libkf5windowsystem-dev (>= 5.12.0~),
               libqt5webkit5-dev (>= 5.2.0~),
               pkg-kde-tools (>= 0.5.0),
               qtbase5-dev (>= 5.2.0~),
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 3.9.6
Homepage: https://projects.kde.org/libkgapi
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/libkgapi.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-kde/kde-extras/libkgapi.git

Package: libkf5gapi-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: libkf5calendarcore-dev (>= 4.81.0~),
         libkf5contacts-dev (>= 4.91.0~),
         libkf5coreaddons-dev (>= 5.12.0~),
         libkf5gapiblogger5 (= ${binary:Version}),
         libkf5gapicalendar5 (= ${binary:Version}),
         libkf5gapicontacts5 (= ${binary:Version}),
         libkf5gapicore5 (= ${binary:Version}),
         libkf5gapidrive5 (= ${binary:Version}),
         libkf5gapilatitude5 (= ${binary:Version}),
         libkf5gapimaps5 (= ${binary:Version}),
         libkf5gapitasks5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Google API library for KDE -- development files
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This package contains development files for building software that uses
 the LibKGAPI library.

Package: libkf5gapi-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Google API library for KDE -- data files
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This package contains data files.

Package: libkf5gapiblogger5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Blogger service API
 This package is part of libkgapi.

Package: libkf5gapicalendar5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Calendar service API
 This package is part of libkgapi.

Package: libkf5gapicontacts5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Contacts service API
 This package is part of libkgapi.

Package: libkf5gapicore5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: core library to integrate with Google service APIs
 This package is part of libkgapi.

Package: libkf5gapidrive5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Drive service API
 This package is part of libkgapi.

Package: libkf5gapilatitude5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Latitude service API
 This package is part of libkgapi.

Package: libkf5gapimaps5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Maps service API
 This package is part of libkgapi.

Package: libkf5gapitasks5
Architecture: any
Multi-Arch: same
Depends: libkf5gapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Tasks service API
 This package is part of libkgapi.

Package: libkf5gapi-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: libkf5gapiblogger5 (= ${binary:Version}) | libkf5gapimaps5 (= ${binary:Version}) | libkf5gapicalendar5 (= ${binary:Version}) | libkf5gapicontacts5 (= ${binary:Version}) | libkf5gapicore5 (= ${binary:Version}) | libkf5gapidrive5 (= ${binary:Version}) | libkf5gapilatitude5 (= ${binary:Version}) | libkf5gapimaps5 (= ${binary:Version}) | libkf5gapitasks5 (= ${binary:Version}),
         ${misc:Depends}
Description: Google API library for KDE -- debugging symbols
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This package contains the debugging symbols for the LibKGAPI library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/3/debian-qt-kde.mk

override_dh_strip:
	$(overridden_command) --dbg-package=libkf5gapi-dbg

override_dh_auto_test:
	# Disable auto test at build time, fakeroot breaks them
	:

=== debian/watch ===
version=3
http://download.kde.org/stable/libkgapi/([\d.]+)/src/libkgapi-([\d.]+)\.tar\.xz
http://download.kde.org/unstable/libkgapi/([\d.]+)/src/libkgapi-([\d.]+)\.tar\.xz

## libkgapi 17.04.3

=== debian/changelog ===
libkgapi (17.04.3-0ubuntu1) artful; urgency=medium

  [ Jonathan Riddell ]
  * Package moved to KDE Applications

  [ Rik Mills ]
  * Upstream beta release (17.03.80)
  * Make QtWebEngine build dependency required on all architectures
    again, as this is now not optional and builds will just fail if it
    is excluded

  [ José Manuel Santamaría Lema ]
  * New upstream release (17.04.1)
  * Install translations and add Breaks/Replaces against kde-l10n
  * Add libkf5gapi-data depend on libkpimgapi-data
  * Add libqt5webengine5 to depends, needed for authentication with
    google
  * New upstream release (17.04.2)
  * New upstream release (17.04.3)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Fri, 18 Aug 2017 08:35:00 +0100

libkgapi (5.3.1-0ubuntu2) artful; urgency=medium

  * Increase minimum KDE PIM build depends. 

 -- Rik Mills <rikmills@kubuntu.org>  Mon, 01 May 2017 13:55:35 +0100

libkgapi (5.3.1-0ubuntu1) artful; urgency=medium

  [ Clive Johnston ]
  * Update Vcs entries to point to Launchpad
  * New upstream release (5.3.1)
  * Refreshing symbols
  * Adding new build dep libqt5webengine5-dev but not for arm64 or ppc64el
    as webengine is not available on these arch
  * Bump standards version to 3.9.8
  * Bump min Frameworks version to KF5.28

  [ Rik Mills ]
  * Also exclude qtwebengine build dep on s390x and powerpc
    architectures.

 -- Clive Johnston <clivejo@kubuntu.org>  Mon, 01 May 2017 13:46:05 +0100

libkgapi (5.1.0-2) unstable; urgency=medium

  [ Automatic packaging ]
  * Bump Standards-Version to 3.9.8
  * Update symbols files from buildds logs (5.1.0-1).
  * Migrate dbg package to automatic dbgsym

 -- Maximiliano Curia <maxy@debian.org>  Sat, 28 May 2016 19:54:36 +0200

=== debian/control ===
Source: libkgapi
Section: libs
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.8.12~),
               debhelper (>= 9),
               extra-cmake-modules (>= 5.28.0~),
               libkf5calendarcore-dev (>= 4:17.04.3~),
               libkf5contacts-dev (>= 4:17.04.3~),
               libkf5coreaddons-dev (>= 5.28.0~),
               libkf5kio-dev (>= 5.28.0~),
               libkf5windowsystem-dev (>= 5.28.0~),
               libqt5webchannel5-dev,
               libqt5webkit5-dev (>= 5.2.0~),
               pkg-kde-tools (>= 0.5.0),
               qtbase5-dev (>= 5.6.0~),
               qtpositioning5-dev,
               qttools5-dev (>= 5.6.0~),
               qttools5-dev-tools (>= 5.6.0~),
               qtwebengine5-dev
Standards-Version: 3.9.8
Homepage: https://projects.kde.org/libkgapi
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libkgapi
Vcs-Git: git://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libkggapi

Package: libkpimgapi-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: libkf5calendarcore-dev (>= 4:17.04.3~),
         libkf5contacts-dev (>= 4:17.04.3~),
         libkf5coreaddons-dev (>= 5.12.0~),
         libkpimgapiblogger5 (= ${binary:Version}),
         libkpimgapicalendar5 (= ${binary:Version}),
         libkpimgapicontacts5 (= ${binary:Version}),
         libkpimgapicore5 (= ${binary:Version}),
         libkpimgapidrive5 (= ${binary:Version}),
         libkpimgapilatitude5 (= ${binary:Version}),
         libkpimgapimaps5 (= ${binary:Version}),
         libkpimgapitasks5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Google API library for KDE -- development files
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This package contains development files for building software that uses
 the LibKGAPI library.

Package: libkpimgapi-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libkf5gapi-data (<< 16.12)
Breaks: libkf5gapi-data (<< 16.12)
Description: Google API library for KDE -- data files
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This package contains data files.

Package: libkf5gapi-data
Architecture: any
Depends: libkpimgapi-data, ${misc:Depends}, ${shlibs:Depends}
Section: oldlibs
Priority: extra
Description: Google API library for KDE -- transitional
 LibKGAPI (previously called LibKGoogle) is a C++ library that implements APIs
 for various Google services.
 .
 This is a transitional package which can be safely removed.

Package: libkpimgapiblogger5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Blogger service API
 This package is part of libkgapi.

Package: libkpimgapicalendar5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Calendar service API
 This package is part of libkgapi.

Package: libkpimgapicontacts5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Contacts service API
 This package is part of libkgapi.

Package: libkpimgapicore5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         libqt5webengine5,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: core library to integrate with Google service APIs
 This package is part of libkgapi.

Package: libkpimgapidrive5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Drive service API
 This package is part of libkgapi.

Package: libkpimgapilatitude5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Latitude service API
 This package is part of libkgapi.

Package: libkpimgapimaps5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Maps service API
 This package is part of libkgapi.

Package: libkpimgapitasks5
Architecture: any
Multi-Arch: same
Depends: libkpimgapi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library to integrate with Google Tasks service API
 This package is part of libkgapi.
